#include "include.h"
#include "macro.h"

#include "plane.h" 
#include "ObjTile.h"
#include "ObjPlane.h"
#include "Objedit.h"

/* Cut, Copy, Paste, Delete and Map functions */
ul	tampx=0,tampy=0;
ul	*tampon=NULL;
ub	*tampon2 = NULL;
ub	tampon_flag=0;

extern	uw	xbox1,xbox2,ybox1,ybox2;

void	set_xybox(void)
{
 ul register temp;
 if (xbox1>xbox2) temp = xbox1, xbox1 = xbox2, xbox2 = temp;
 if (ybox1>ybox2) temp = ybox1, ybox1 = ybox2, ybox2 = temp;
}

void	Copy(void)
{
 ul i,j;
 ul *a0;
 ub *a1;
 
 set_xybox();
 tampx=xbox2-xbox1;
 tampy=ybox2-ybox1;

 free(tampon);
 if (!(tampon = (ul *) malloc((sizeof(ul)) * tampx * tampy * 2 )))
	return;
 a0 = tampon;
 for(j=ybox1; j<ybox2 ; j++)
 for(i=xbox1; i<xbox2 ; i++)
	*(a0++)=get_tile(&Plan,i,j);

 if (Plan.link_no>=0)
	{
	for(j=ybox1; j<ybox2 ; j++)
	for(i=xbox1; i<xbox2 ; i++)
		*(a0++)=get_tile(Plan.Plink, i,j);
	}

 free(tampon2);
 if (!(tampon2 = (ub *) malloc((sizeof(ub)) * tampx * tampy * 2 )))
	return;
 a1 = tampon2;
 for(j=ybox1; j<ybox2 ; j++)
	 for(i=xbox1; i<xbox2 ; i++)
		*(a1++)=get_flag(&Plan,i,j);

 if (Plan.link_no>=0)
	{
	for(j=ybox1; j<ybox2 ; j++)
		for(i=xbox1; i<xbox2 ; i++)
			*(a1++)=get_flag(Plan.Plink, i,j);
	}
}

void	Delete(void)
{
 ul i,j;
 for(j=ybox1; j<ybox2 ; j++)
	 for(i=xbox1; i<xbox2 ; i++)
		{
		set_tile(&Plan,i,j,0);
		set_flag(&Plan,i,j,0);
		}
 if (Plan.link_no>=0)
	 for(j=ybox1; j<ybox2 ; j++)
		 for(i=xbox1; i<xbox2 ; i++)
			{
			set_tile(Plan.Plink,i,j,0);
			set_flag(Plan.Plink,i,j,0);
			}
}

void	Cut(void)
{
 Copy();
 Delete();
}

void	Paste(void)
{
 ul i,j;
 ul *a0;
 ub *a1;

 set_xybox();

 a0 = tampon;
 for(j=ybox1; j<ybox1+tampy ; j++)
 for(i=xbox1; i<xbox1+tampx ; i++)
	if ((j< Plan.height) && (i< Plan.length))
		set_tile(&Plan,i,j,*(a0++));
 if (Plan.link_no >=0)
  {
	for(j=ybox1; j<ybox1+tampy ; j++)
	for(i=xbox1; i<xbox1+tampx ; i++)
	if ((j< Plan.height) && (i< Plan.length))
		set_tile(Plan.Plink,i,j,*(a0++));
  }

 a1 = tampon2;
 for(j=ybox1; j<ybox1+tampy ; j++)
	 for(i=xbox1; i<xbox1+tampx ; i++)
		if ((j< Plan.height) && (i< Plan.length))
			set_flag(&Plan,i,j,*(a1++));
 if (Plan.link_no >=0)
  {
	for(j=ybox1; j<ybox1+tampy ; j++)
		for(i=xbox1; i<xbox1+tampx ; i++)
			if ((j< Plan.height) && (i< Plan.length))
				set_flag(Plan.Plink,i,j,*(a1++));
  }
}

void	Map(void)
{
 ul i,j,k,l;
 ul *a0;
 ub *a1;
 
 set_xybox();
 
 a0 = tampon;
 l = 0;
 for(j=ybox1; j<ybox2 ; j++)
 {
 k=0;
 for(i=xbox1; i<xbox2 ; i++)
	{
	set_tile(&Plan,i,j,*(a0 + l*tampx + k));
	if (++k>=tampx) k =0;
	}
 if (++l>=tampy) l =0;
 }

 if (Plan.link_no >0)
  {
	l = 0;
	a0 += tampx * tampy;
	for(j=ybox1; j<ybox2 ; j++)
	{
	k=0;
	for(i=xbox1; i<xbox2 ; i++)
		{
		set_tile(Plan.Plink,i,j,*(a0 + l*tampx + k));
		if (++k>=tampx) k =0;
		}
	if (++l>=tampy) l =0;
	}
  }

 a1 = tampon2;
 l = 0;
 for(j=ybox1; j<ybox2 ; j++)
	 {
	 k=0;
	 for(i=xbox1; i<xbox2 ; i++)
		{
		set_flag(&Plan,i,j,*(a1 + l*tampx + k));
		if (++k>=tampx) k =0;
		}
	if (++l>=tampy) l =0;
	}

 if (Plan.link_no >0)
	{
	l = 0;
	a1 += tampx * tampy;
	for(j=ybox1; j<ybox2 ; j++)
		{
		k=0;
		for(i=xbox1; i<xbox2 ; i++)
			{
			set_flag(Plan.Plink,i,j,*(a1 + l*tampx + k));
			if (++k>=tampx) k =0;
			}
		if (++l>=tampy) l =0;
		}
  }

}
