#include "include.h"
#include "macro.h"
#include "ObjTile.h"

extern BITMAP *buffer;	/* Ecran de sortie*/

/* Structure d'un plan */
typedef struct plane_struct Plane;

struct plane_struct
{
char	mat_file[MXS];	// Nom du fichier binaire du plan
char	tile_name[MXS];	// Nom du fichier binaire des dessins
char	link_file[MXS];	// Nom du fichier link
ul		skip_byte;	// Nombre d'octets a sauter avant d'ecrire le plan
ul		height;		// Hauteur
ul		length;		// Largeur
ul		sub_height;	// Sous hauteur
ul		sub_length;	// Sous largeur
ul		xs;		// Coordonnee horizontale du scroling
ul		ys;		// Coordonnee verticale du scrolling
ul		list_no;	// Selection courante dans la liste des dessins
ul		list_no2;	// 2eme Selection ds la liste
sl		list_s;		// Coordonnee du scrolling courant de la liste
sl		link_no;	// Numro du plan link, -1 si aucun
Plane*	Plink;	// Pointeur vers le plan link
ub*		link_tab;	// Adresse de la table de linkage
ul		type;		// Type des dessins
ul		taille;		// Taille des dessins : ce doit etre des carres (ex: 8, 16, 32)
ul		tile_no;	// Nombre de dessins charges
ul*		pl_tab;		// Pointeur vers le tableau du plan
ub*		pl_flag;	// Pointeur vers le tableau des flags du plan
char	mask[MXS];	// Masque "intelligent"
ul		num_tiles;	// Nombre de tiles maximun pour une case = 2 ^ num_abits
ul		num_bits;	// Nombre de bits pour une case
ul		num_abits;	// Nombre de bits actifs pour une case (<= num_bits)
uw		bit_set[31+1];
sl		bit_fliph;	// Bit de flip horizontal ou -1
sl		bit_flipv;	// Bit de flip vertical ou -1
BITMAP** tile;		// Table de pointeurs vers les dessins
};


/* Dfinition des fonctions */
void init_plane(Plane *);
void init_plane2(Plane *);
void free_plane(Plane *);
void save_matrix(Plane *);
ub   open_plane(Plane *, uw);
void open_link(Plane *);
void save_link(Plane *);
void print_Ptile(Plane *, ul, ul, ul,uw);
ul   select_link(Plane *, ul);
void edit_link(Plane *);
void save_plane_as_bitmap(Plane *P);

ul   get_tile(Plane*, ul, ul);
void set_tile(Plane*, ul, ul, ul);
ub   get_flag(Plane*, ul, ul);
void set_flag(Plane*, ul, ul, ub);
void translate_mask(Plane*);

void fliph(Plane* , ul ,ul);
void flipv(Plane* , ul ,ul);

#ifdef	LOW_ENDIAN
#define	ENDIAN 0
#endif
#ifdef BIG_ENDIAN
#define ENDIAN 1
#endif

